//------------------------------------------------------------------
//
//
//------------------------------------------------------------------
#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   clrLime
#property indicator_color2   clrRed
#property indicator_width1   2
#property indicator_width2   2
#property strict


extern int    FirstBufferNumber  = 3; // Fisrt buffer number
extern int    SecondBufferNumber = 6; // Second buffer number
extern int    StateBuffer        = 10;// State "trend" buffer number

extern string IndicatorName      = "Smoother (r-squared) adaptive (experiment)"; // Indicator name to use

string  bufferName = "Buffer Smoother(r-squared)";
bool returnBars;

double Buffer1[],Buffer2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
int init() 
{
  
     
   
   SetIndexBuffer(0 ,Buffer1);
   SetIndexBuffer(1 ,Buffer2);
   
   
   IndicatorShortName("Exploring buffers ("+(string)FirstBufferNumber+","+(string)SecondBufferNumber+") of "+IndicatorName);
   
   if (ObjectFind(bufferName)!=0)
   {
       ObjectCreate(ChartID(),bufferName,OBJ_BUTTON,0,0,0);
         ObjectSetString(ChartID(),bufferName,OBJPROP_TEXT,"Smoother(r-sqr) is on");
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_YDISTANCE,262);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_XDISTANCE,2);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_XSIZE,190);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_YSIZE,20);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),bufferName,OBJPROP_STATE,true);
   }
   return(0);
}

void OnDeinit(const int reason)
{ 
   if (!returnBars)
      switch(reason)
      {
         case REASON_PARAMETERS  :
         case REASON_CHARTCHANGE :
         case REASON_RECOMPILE   :
         case REASON_CLOSE       : break;
         default :
         {
            ObjectDelete(bufferName);
         }                  
      }
}

void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
   static string prevState ="";
   if (id==CHARTEVENT_OBJECT_CLICK && sparam==bufferName)
   {
   string newState = GetButtonState(bufferName);
         if (newState!=prevState)
         if (newState=="off")
         { 
            for (int i=0; i<3; i++) SetIndexStyle(i,DRAW_NONE);
            prevState=newState;
         }
         else  
         { 
            for (int i=0; i<3; i++) SetIndexStyle(i,DRAW_LINE);
            prevState=newState;
         }
         
           ObjectSetString(ChartID(),bufferName,OBJPROP_TEXT,"Smoother(r-sqr) is "+newState);
   }

   
}
//
//
//
//
//

int start() 
{
   int trend = 0;
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   for(int i=limit; i>=0; i--)
   {
      if (FirstBufferNumber >=0) Buffer1[i] = iCustom(NULL,0,IndicatorName,0,25,21,0.0,0,1,25,90.0,10.0,0,32768,17919,5197615,3223838,5,true,FirstBufferNumber,i);
      if (SecondBufferNumber>=0) Buffer2[i] = iCustom(NULL,0,IndicatorName,0,25,21,0.0,0,1,25,90.0,10.0,0,32768,17919,5197615,3223838,5,true,SecondBufferNumber,i);
   }
   
   trend = int(iCustom(NULL,0,IndicatorName,0,25,21,0.0,0,1,25,90.0,10.0,0,32768,17919,5197615,3223838,5,true,StateBuffer,0));
   if(trend == 1) ObjectSetInteger(ChartID(),bufferName,OBJPROP_BGCOLOR,clrGreen);
   if(trend == 0) ObjectSetInteger(ChartID(),bufferName,OBJPROP_BGCOLOR,clrDimGray);
   if(trend ==-1) ObjectSetInteger(ChartID(),bufferName,OBJPROP_BGCOLOR,clrFireBrick);
   
   return(0); 
}

string GetButtonState(string whichbutton)
{
    bool selected=ObjectGetInteger(ChartID(),whichbutton,OBJPROP_STATE);
    if (selected)
        {return ("on");} 
    else
        {return ("off");}
}